
Require Import ZArith.
Require Import Div2.
Require Import Recdef.
Open Scope Z_scope.

Check 3 / 2.
Check 3 mod 2.

Compute 3 mod 2.

Fixpoint pow_z (z : Z) (n : nat) : Z :=
  match n with
    | O => 1
    | S n' => z * pow_z z n'
  end.

Function pow_z' (zp z : Z) (n : nat) { measure (fun i => i) n } : Z :=
  match n with
    | O => zp
    | _ => if Even.even_odd_dec n
           then pow_z' zp (z*z) (div2 n)
           else pow_z' (zp*z) (z*z) (div2 n)
  end.
Proof.
  intros; apply lt_div2; auto with arith.
  intros; apply lt_div2; auto with arith.
Defined.

Definition mod_value (z p : Z) (m : nat) : Z :=
  (z / pow_z p m) mod (pow_z p (S m)).
