open Complex

let fac k n =
  let m2pi = -8.0 *. atan 1. in
  polar 1.0 (m2pi*.(float k)/.(float n))
 
let merge l r n =
  let f (k,t) x = (succ k, (mul (fac k n) x) :: t) in
  let z = List.rev (snd (List.fold_left f (0,[]) r)) in
  (List.map2 add l z) @ (List.map2 sub l z)
 
let fft lst =
  let rec ditfft2 a n s =
    if n = 1 then [List.nth lst a] else
    let odd = ditfft2 a (n asr 1) (s lsl 1) in
    let even = ditfft2 (a+s) (n asr 1) (s lsl 1) in
    merge odd even n in
  ditfft2 0 (List.length lst) 1

